/*------------------------------------------------------------------------------
 *
 * Calculate_ABG2V() - Called from Menu_A() -
 *                     1.  Calculates the value of Alpha, Beta, Gamma, or Two_Vx
 *                         (2Vx) depending on the value of Achoice.
 *                     2.  When the calculation is complete, the values of all
 *                         variables are diplayed to the screen.  The display is
 *                         stopped from scrolling to allow the user to read the
 *                         results - the return key must be pressed to continue.
 *
 *------------------------------------------------------------------------------
 */

#include "opt_cal.h"
Calculate_ABG2V(Alpha,Beta,Gamma,Two_Vx,Achoice)
double Alpha;            /* smallest refractive index            */
double Beta;             /* intermediate refractive index        */
double Gamma;            /* largest refractive index             */
double Two_Vx;           /* two V of minerals                    */
char Achoice;            /* determines variable to be solved for */
{
  char x;                        /* dummy scanning variable           */
  double Temp1;                  /* temporary variable                */
  double Two_Vz;                 /*  == 180 - Two_Vx                  */
  double Radian = 57.29577951;   /* conversion for degrees to radians */

  extern double sqr();

  switch(Achoice)
  {
    case '1' : Temp1 = sqr(Beta)/2 *
                       (cos(Two_Vx/Radian)+1) /
                       sqr(Gamma);

               Alpha = sqrt(
                             (sqr(Beta)-sqr(Gamma)*Temp1) /
                             (1 - Temp1)
                           );
               break;

    case '2' : Beta = sqrt( sqr(Alpha) /
                            (
                              (0.5) *
                              (sqr(Alpha)/sqr(Gamma)-1) *
                              (cos(Two_Vx/Radian)+1) +
                              1
                            )
                          );
               break;

    case '3' : Gamma = sqrt ( sqr(Alpha) / (( ((sqr(Alpha) /
    																										sqr(Beta)) - 1 ) /
    																										(0.5 * (cos(Two_Vx/Radian) + 1))) +
    																										1
    																								)
    																						);			
               break;

    case '4' : Two_Vx = Radian * acos( 2* (
                                            (sqr(Alpha)/sqr(Beta)-1) /
                                            (sqr(Alpha)/sqr(Gamma)-1)
                                          )
                                       -1
                                     );
               break;

  }/*END SWITCH*/

  Two_Vz = 180 - Two_Vx;

  printf("\n\tAlpha = %.4f\n", Alpha);
  printf("\tBeta  = %.4f\n", Beta);
  printf("\tGamma = %.4f\n", Gamma);
  printf("\t2Vx   = %.2f\n", Two_Vx);
  printf("\t2Vz   = %.2f\n", Two_Vz);
  fflush(stdin);
  printf("\nPress 'Return' to continue\n\n");
  scanf("%c", &x);
}/*END Calculate_ABG2V*/
/*-----------------------------------------------------------------------------*/
