/*------------------------------------------------------------------------------
 *
 * Calculate_Retardation() - Called from Menu_C() -
 *                           1.  Calculates the value of Retardation,
 *                               Birefringence, or Thickness depending on the
 *                               value of Cchoice.
 *                           2.  When the calculation is complete, the values of
 *                               all variables are diplayed to the screen.  The
 *                               display is stopped from scrolling to allow the
 *                               user to read the results - the return key
 *                               must be pressed to continue.
 *
 *------------------------------------------------------------------------------
 */

#include "opt_cal.h"
Calculate_Retardation(Retdn,Biref,Thick,Cchoice)
double Retdn;               /* Retardation                          */
double Biref;               /* Birefringence                        */
double Thick;               /* Thickness                            */
char Cchoice;               /* determines variable to be solved for */
{
  char x;                   /* dummy scanning variable  */

  switch(Cchoice)
  {
    case '1' : Retdn = Biref * Thick * 1000;
               break;

    case '2' : Biref = Retdn / (Thick*1000);
               break;

    case '3' : Thick = Retdn / (Biref*1000);
               break;

  }/*END SWITCH*/

  printf("\n\tRetardation    = %.1f nm.\n", Retdn);
  printf("\tBirefringence  = %.4f\n", Biref);
  printf("\tThickness      = %.1f microns.\n", Thick);
  fflush(stdin);
  printf("\nPress 'Return' to continue\n\n");
  scanf("%c", &x);

}/*END Calculate_Retardation*/
/*-----------------------------------------------------------------------------*/
