/*------------------------------------------------------------------------------
 *
 * Menu_C() - Called from main() - Diplays the menu for performing Retardation -
 *            Birefringence calculations and scans for user input.  Depending
 *            on user input Menu_C() will:
 *
 *            1.  Prompt the user and scan for the two remaining variables via
 *                the switch-case statement.
 *                 a) For each value that is entered, Test_Inputs() is called
 *                    to ensure that it is a valid number.
 *                 b) Report_Error() is called to report an out of range
 *                    condition if any of the entered numbers fail the range
 *                    checking for this equation.
 *                 c) Calculate_Retardation() is called to perform the required
 *                    computation if all numerical values are good.
 *            2.  Call Report_Error() for invalid menu selection.
 *            3.  Exit and return to the main menu.
 *
 *------------------------------------------------------------------------------
 */
#include "opt_cal.h"
Menu_C()
{
  char Cchoice;               /* Menu choice scanning variable    */
  char Cscan[20];													/* floating point scanning variable */
  int  MenuFlag;              /* Menu selection flag              */

  double Retdn;               /* Retardation   */
  double Biref;               /* Birefringence */
  double Thick;               /* Thickness     */

  extern Calculate_Retardation();
  extern double Test_Inputs();
  extern Report_Error();

  do
  {
    Retdn = Biref = Thick = MenuFlag = 1;

		  printf("\n\n\n\n\n\n\n\n\n\n\n\n");
		  printf("\tMenu C:  Retardation/Birefringence Calculations\n\n");
		  printf("\tWhich would you like to calculate?\n\n");
		  printf("\t(1) Retardation (nm).\n\n");
		  printf("\t(2) Birefringence.\n\n");
		  printf("\t(3) Thickness (microns).\n\n");
		  printf("\t(Q) Return to Main Menu.\n\n");
		  printf("\tEnter Selection and press 'Return':  ");
		
		  fflush(stdin);
		  scanf("%1c", &Cchoice);
		  fflush(stdin);
		
		  switch(Cchoice)
		  {
		    case '1' : do
		               {
		                fflush(stdin);
		                printf("\n\tEnter Birefringence          (n.nnnn) -> ");
		                scanf("%20s", &Cscan);
		               }while( (Biref = Test_Inputs(Cscan)) == HUGE_VAL );
		               do
		               {
		                fflush(stdin);
		                printf("\tEnter Thickness (in microns)  (nnn.n) -> ");
		                scanf("%20s", &Cscan);
		               }while( (Thick = Test_Inputs(Cscan)) == HUGE_VAL );
                 break;

		    case '2' : do
		               {
		                fflush(stdin);
		                printf("\n\tEnter Retardation (in nm)   (nnnnnnn) -> ");
		                scanf("%20s", &Cscan);
		               }while( (Retdn = Test_Inputs(Cscan)) == HUGE_VAL );
		               do
		               {
		                fflush(stdin);
		                printf("\tEnter Thickness (in microns)  (nnn.n) -> ");
		                scanf("%20s", &Cscan);
		               }while( (Thick = Test_Inputs(Cscan)) == HUGE_VAL );
                 break;

		    case '3' : do
		               {
		                fflush(stdin);
		                printf("\n\tEnter Retardation (in nm) (nnnnnnn) -> ");
		                scanf("%20s", &Cscan);
		               }while( (Retdn = Test_Inputs(Cscan)) == HUGE_VAL );
		               do
		               {
		                fflush(stdin);
		                printf("\tEnter Birefringence        (n.nnnn) -> ");
		                scanf("%20s", &Cscan);
		               }while( (Biref = Test_Inputs(Cscan)) == HUGE_VAL );
                 break;

		    case 'q' :
		    case 'Q' : MenuFlag = 0;
		               printf("\n\nReturn to Main Menu.\n\n\n");
		               break;
		
		    default  : Report_Error(1);
		               MenuFlag = 0;
		               break;
		  }/*END SWITCH*/

    if( Retdn <= 0 || Retdn >  2000000 || Biref <= 0   ||
        Biref >  2 || Thick <= 0       || Thick >  1000 )
      Report_Error(6);

    else if(MenuFlag != 0) Calculate_Retardation(Retdn,Biref,Thick,Cchoice);
 } while(Cchoice != 'q' && Cchoice != 'Q');
}/*END Menu_C*/
/*-----------------------------------------------------------------------------*/
